Subject: Re: NNCP discussion on comp.mail.uucp

From: John Goerzen <[email-masked]>
Date: Tue, 05 Jan 2021 10:01:58 -0600

On Tue, Jan 05 2021, Sergey Matveev wrote:

>>NNCP automatic tossing.
>>also had automatic calling
>
> Both of these looks like easy to add.

Sweet!

> Here I just want to add trivial comments for 
> https://floss.social/@jgoerzen/105499269925205743
>
> * Protection against Silent Data Corruption. Just want to 
> mention that
>   automatic self-healing (data correction) is performed also on 
>   a setup
>   with just single disk. "Data" blocks, by default has just 
>   single copy
>   and obviously they can not be repaired without redundancy. But 
>   metadata
>   blocks ("inodes", dataset/zvol descriptions, block pointers, 
>   and so on)
>   by default has copies=2 and physically they have two copies on 
>   the
>   disk. Very important metadata blocks (meta object set (MOS),
>   überblock) has copies=3. So metadata has (by default) 
>   redundancy and
>   can be repaired by reading the copy from another part of the 
>   disk

Very true indeed.

> * Built-in #compression with fast algorithms. Compression (at 
> least the
>   most simple rle one) should be enabled also because sparse
>   (zero-filled) blocks won't be allocated at all. If no 
>   compression is
>   enabled, then sparse files will be allocated and written to 
>   the disk

I did mention this one in the thread.  I personally use lz4 on all 
my zpools but I'm happy to see that zstd has been integrated now 
as well!

Should have better compression ratios AND better performance.

- John